<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    package com.jmatio.types;<a name="line.1"></a>
<FONT color="green">002</FONT>    <a name="line.2"></a>
<FONT color="green">003</FONT>    import java.util.Arrays;<a name="line.3"></a>
<FONT color="green">004</FONT>    <a name="line.4"></a>
<FONT color="green">005</FONT>    /**<a name="line.5"></a>
<FONT color="green">006</FONT>     * Abstract class for numeric arrays.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * @author Wojciech Gradkowski &lt;wgradkowski@gmail.com&gt;<a name="line.8"></a>
<FONT color="green">009</FONT>     *<a name="line.9"></a>
<FONT color="green">010</FONT>     * @param &lt;T&gt;<a name="line.10"></a>
<FONT color="green">011</FONT>     */<a name="line.11"></a>
<FONT color="green">012</FONT>    /**<a name="line.12"></a>
<FONT color="green">013</FONT>     * @author Wojciech Gradkowski &lt;wgradkowski@gmail.com&gt;<a name="line.13"></a>
<FONT color="green">014</FONT>     *<a name="line.14"></a>
<FONT color="green">015</FONT>     * @type &lt;T&gt;      the number type<a name="line.15"></a>
<FONT color="green">016</FONT>     */<a name="line.16"></a>
<FONT color="green">017</FONT>    public abstract class MLNumericArray&lt;T extends Number&gt; extends MLArray implements GenericArrayCreator&lt;T&gt;<a name="line.17"></a>
<FONT color="green">018</FONT>    {<a name="line.18"></a>
<FONT color="green">019</FONT>        private T[] real;<a name="line.19"></a>
<FONT color="green">020</FONT>        private T[] imaginary;<a name="line.20"></a>
<FONT color="green">021</FONT>        <a name="line.21"></a>
<FONT color="green">022</FONT>        /**<a name="line.22"></a>
<FONT color="green">023</FONT>         * Normally this constructor is used only by MatFileReader and MatFileWriter<a name="line.23"></a>
<FONT color="green">024</FONT>         * <a name="line.24"></a>
<FONT color="green">025</FONT>         * @param name - array name<a name="line.25"></a>
<FONT color="green">026</FONT>         * @param dims - array dimensions<a name="line.26"></a>
<FONT color="green">027</FONT>         * @param type - array type<a name="line.27"></a>
<FONT color="green">028</FONT>         * @param attributes - array flags<a name="line.28"></a>
<FONT color="green">029</FONT>         */<a name="line.29"></a>
<FONT color="green">030</FONT>        public MLNumericArray(String name, int[] dims, int type, int attributes)<a name="line.30"></a>
<FONT color="green">031</FONT>        {<a name="line.31"></a>
<FONT color="green">032</FONT>            super(name, dims, type, attributes);<a name="line.32"></a>
<FONT color="green">033</FONT>            <a name="line.33"></a>
<FONT color="green">034</FONT>            real = createArray(getM(), getN());<a name="line.34"></a>
<FONT color="green">035</FONT>            imaginary = createArray(getM(), getN());<a name="line.35"></a>
<FONT color="green">036</FONT>        }<a name="line.36"></a>
<FONT color="green">037</FONT>        /**<a name="line.37"></a>
<FONT color="green">038</FONT>         * &lt;a href="http://math.nist.gov/javanumerics/jama/"&gt;Jama&lt;/a&gt; [math.nist.gov] style: <a name="line.38"></a>
<FONT color="green">039</FONT>         * construct a 2D real matrix from a one-dimensional packed array<a name="line.39"></a>
<FONT color="green">040</FONT>         * <a name="line.40"></a>
<FONT color="green">041</FONT>         * @param name - array name<a name="line.41"></a>
<FONT color="green">042</FONT>         * @param type - array type<a name="line.42"></a>
<FONT color="green">043</FONT>         * @param vals - One-dimensional array of doubles, packed by columns (ala Fortran).<a name="line.43"></a>
<FONT color="green">044</FONT>         * @param m - Number of rows<a name="line.44"></a>
<FONT color="green">045</FONT>         */<a name="line.45"></a>
<FONT color="green">046</FONT>        public MLNumericArray(String name, int type, T[] vals, int m )<a name="line.46"></a>
<FONT color="green">047</FONT>        {<a name="line.47"></a>
<FONT color="green">048</FONT>            this(name, new int[] {  m, vals.length/m }, type, 0);<a name="line.48"></a>
<FONT color="green">049</FONT>            //fill the array<a name="line.49"></a>
<FONT color="green">050</FONT>            for ( int i = 0; i &lt; vals.length; i++ )<a name="line.50"></a>
<FONT color="green">051</FONT>            {<a name="line.51"></a>
<FONT color="green">052</FONT>                set( vals[i], i );<a name="line.52"></a>
<FONT color="green">053</FONT>            }<a name="line.53"></a>
<FONT color="green">054</FONT>        }<a name="line.54"></a>
<FONT color="green">055</FONT>        /**<a name="line.55"></a>
<FONT color="green">056</FONT>         * Gets single real array element of A(m,n).<a name="line.56"></a>
<FONT color="green">057</FONT>         * <a name="line.57"></a>
<FONT color="green">058</FONT>         * @param m - row index<a name="line.58"></a>
<FONT color="green">059</FONT>         * @param n - column index<a name="line.59"></a>
<FONT color="green">060</FONT>         * @return - array element<a name="line.60"></a>
<FONT color="green">061</FONT>         */<a name="line.61"></a>
<FONT color="green">062</FONT>        public T getReal(int m, int n)<a name="line.62"></a>
<FONT color="green">063</FONT>        {<a name="line.63"></a>
<FONT color="green">064</FONT>            return real[getIndex(m,n)];<a name="line.64"></a>
<FONT color="green">065</FONT>        }<a name="line.65"></a>
<FONT color="green">066</FONT>        /**<a name="line.66"></a>
<FONT color="green">067</FONT>         * Sets single real array element.<a name="line.67"></a>
<FONT color="green">068</FONT>         * <a name="line.68"></a>
<FONT color="green">069</FONT>         * @param value - element value<a name="line.69"></a>
<FONT color="green">070</FONT>         * @param m - row index<a name="line.70"></a>
<FONT color="green">071</FONT>         * @param n - column index<a name="line.71"></a>
<FONT color="green">072</FONT>         */<a name="line.72"></a>
<FONT color="green">073</FONT>        public void setReal(T value, int m, int n)<a name="line.73"></a>
<FONT color="green">074</FONT>        {<a name="line.74"></a>
<FONT color="green">075</FONT>            real[getIndex(m,n)] = value;<a name="line.75"></a>
<FONT color="green">076</FONT>        }<a name="line.76"></a>
<FONT color="green">077</FONT>        /**<a name="line.77"></a>
<FONT color="green">078</FONT>         * Sets single real array element.<a name="line.78"></a>
<FONT color="green">079</FONT>         * <a name="line.79"></a>
<FONT color="green">080</FONT>         * @param value - element value<a name="line.80"></a>
<FONT color="green">081</FONT>         * @param index - column-packed vector index<a name="line.81"></a>
<FONT color="green">082</FONT>         */<a name="line.82"></a>
<FONT color="green">083</FONT>        public void setReal(T value, int index)<a name="line.83"></a>
<FONT color="green">084</FONT>        {<a name="line.84"></a>
<FONT color="green">085</FONT>            real[index] = value;<a name="line.85"></a>
<FONT color="green">086</FONT>        }<a name="line.86"></a>
<FONT color="green">087</FONT>        /**<a name="line.87"></a>
<FONT color="green">088</FONT>         * Sets real part of matrix<a name="line.88"></a>
<FONT color="green">089</FONT>         * <a name="line.89"></a>
<FONT color="green">090</FONT>         * @param vector - column-packed vector of elements<a name="line.90"></a>
<FONT color="green">091</FONT>         */<a name="line.91"></a>
<FONT color="green">092</FONT>        public void setReal( T[] vector )<a name="line.92"></a>
<FONT color="green">093</FONT>        {<a name="line.93"></a>
<FONT color="green">094</FONT>            if ( vector.length != getSize() )<a name="line.94"></a>
<FONT color="green">095</FONT>            {<a name="line.95"></a>
<FONT color="green">096</FONT>                throw new IllegalArgumentException("Matrix dimensions do not match. " + getSize() + " not " + vector.length);<a name="line.96"></a>
<FONT color="green">097</FONT>            }<a name="line.97"></a>
<FONT color="green">098</FONT>            System.arraycopy(vector, 0, real, 0, vector.length);<a name="line.98"></a>
<FONT color="green">099</FONT>        }<a name="line.99"></a>
<FONT color="green">100</FONT>        /**<a name="line.100"></a>
<FONT color="green">101</FONT>         * Sets single imaginary array element.<a name="line.101"></a>
<FONT color="green">102</FONT>         * <a name="line.102"></a>
<FONT color="green">103</FONT>         * @param value - element value<a name="line.103"></a>
<FONT color="green">104</FONT>         * @param m - row index<a name="line.104"></a>
<FONT color="green">105</FONT>         * @param n - column index<a name="line.105"></a>
<FONT color="green">106</FONT>         */<a name="line.106"></a>
<FONT color="green">107</FONT>        public void setImaginary(T value, int m, int n)<a name="line.107"></a>
<FONT color="green">108</FONT>        {<a name="line.108"></a>
<FONT color="green">109</FONT>            imaginary[getIndex(m,n)] = value;<a name="line.109"></a>
<FONT color="green">110</FONT>        }<a name="line.110"></a>
<FONT color="green">111</FONT>        /**<a name="line.111"></a>
<FONT color="green">112</FONT>         * Sets single real array element.<a name="line.112"></a>
<FONT color="green">113</FONT>         * <a name="line.113"></a>
<FONT color="green">114</FONT>         * @param value - element value<a name="line.114"></a>
<FONT color="green">115</FONT>         * @param index - column-packed vector index<a name="line.115"></a>
<FONT color="green">116</FONT>         */<a name="line.116"></a>
<FONT color="green">117</FONT>        public void setImaginary(T value, int index)<a name="line.117"></a>
<FONT color="green">118</FONT>        {<a name="line.118"></a>
<FONT color="green">119</FONT>            imaginary[index] = value;<a name="line.119"></a>
<FONT color="green">120</FONT>        }<a name="line.120"></a>
<FONT color="green">121</FONT>        /**<a name="line.121"></a>
<FONT color="green">122</FONT>         * Gets single imaginary array element of A(m,n).<a name="line.122"></a>
<FONT color="green">123</FONT>         * <a name="line.123"></a>
<FONT color="green">124</FONT>         * @param m - row index<a name="line.124"></a>
<FONT color="green">125</FONT>         * @param n - column index<a name="line.125"></a>
<FONT color="green">126</FONT>         * @return - array element<a name="line.126"></a>
<FONT color="green">127</FONT>         */<a name="line.127"></a>
<FONT color="green">128</FONT>        public T getImaginary(int m, int n)<a name="line.128"></a>
<FONT color="green">129</FONT>        {<a name="line.129"></a>
<FONT color="green">130</FONT>            return imaginary[getIndex(m,n)];<a name="line.130"></a>
<FONT color="green">131</FONT>        }<a name="line.131"></a>
<FONT color="green">132</FONT>        /**<a name="line.132"></a>
<FONT color="green">133</FONT>         * Exports column-packed vector of real elements<a name="line.133"></a>
<FONT color="green">134</FONT>         * <a name="line.134"></a>
<FONT color="green">135</FONT>         * @return - column-packed vector of real elements<a name="line.135"></a>
<FONT color="green">136</FONT>         */<a name="line.136"></a>
<FONT color="green">137</FONT>        public T[] exportReal()<a name="line.137"></a>
<FONT color="green">138</FONT>        {<a name="line.138"></a>
<FONT color="green">139</FONT>            return real.clone();<a name="line.139"></a>
<FONT color="green">140</FONT>        }<a name="line.140"></a>
<FONT color="green">141</FONT>        /**<a name="line.141"></a>
<FONT color="green">142</FONT>         * Exports column-packed vector of imaginary elements<a name="line.142"></a>
<FONT color="green">143</FONT>         * <a name="line.143"></a>
<FONT color="green">144</FONT>         * @return - column-packed vector of imaginary elements<a name="line.144"></a>
<FONT color="green">145</FONT>         */<a name="line.145"></a>
<FONT color="green">146</FONT>        public T[] exportImaginary()<a name="line.146"></a>
<FONT color="green">147</FONT>        {<a name="line.147"></a>
<FONT color="green">148</FONT>            return imaginary.clone();<a name="line.148"></a>
<FONT color="green">149</FONT>        }<a name="line.149"></a>
<FONT color="green">150</FONT>        /**<a name="line.150"></a>
<FONT color="green">151</FONT>         * Does the same as &lt;code&gt;setReal&lt;/code&gt;.<a name="line.151"></a>
<FONT color="green">152</FONT>         * <a name="line.152"></a>
<FONT color="green">153</FONT>         * @param value - element value<a name="line.153"></a>
<FONT color="green">154</FONT>         * @param m - row index<a name="line.154"></a>
<FONT color="green">155</FONT>         * @param n - column index<a name="line.155"></a>
<FONT color="green">156</FONT>         */<a name="line.156"></a>
<FONT color="green">157</FONT>        public void set(T value, int m, int n)<a name="line.157"></a>
<FONT color="green">158</FONT>        {<a name="line.158"></a>
<FONT color="green">159</FONT>            if ( isComplex() )<a name="line.159"></a>
<FONT color="green">160</FONT>            {<a name="line.160"></a>
<FONT color="green">161</FONT>                throw new IllegalStateException("Cannot use this method for Complex matrices");<a name="line.161"></a>
<FONT color="green">162</FONT>            }<a name="line.162"></a>
<FONT color="green">163</FONT>            setReal(value, m, n);<a name="line.163"></a>
<FONT color="green">164</FONT>        }<a name="line.164"></a>
<FONT color="green">165</FONT>        /**<a name="line.165"></a>
<FONT color="green">166</FONT>         * Does the same as &lt;code&gt;setReal&lt;/code&gt;.<a name="line.166"></a>
<FONT color="green">167</FONT>         * <a name="line.167"></a>
<FONT color="green">168</FONT>         * @param value - element value<a name="line.168"></a>
<FONT color="green">169</FONT>         * @param index - column-packed vector index<a name="line.169"></a>
<FONT color="green">170</FONT>         */<a name="line.170"></a>
<FONT color="green">171</FONT>        public void set(T value, int index)<a name="line.171"></a>
<FONT color="green">172</FONT>        {<a name="line.172"></a>
<FONT color="green">173</FONT>            if ( isComplex() )<a name="line.173"></a>
<FONT color="green">174</FONT>            {<a name="line.174"></a>
<FONT color="green">175</FONT>                throw new IllegalStateException("Cannot use this method for Complex matrices");<a name="line.175"></a>
<FONT color="green">176</FONT>            }<a name="line.176"></a>
<FONT color="green">177</FONT>            setReal(value, index);<a name="line.177"></a>
<FONT color="green">178</FONT>        }<a name="line.178"></a>
<FONT color="green">179</FONT>        /**<a name="line.179"></a>
<FONT color="green">180</FONT>         * Does the same as &lt;code&gt;getReal&lt;/code&gt;.<a name="line.180"></a>
<FONT color="green">181</FONT>         * <a name="line.181"></a>
<FONT color="green">182</FONT>         * @param m - row index<a name="line.182"></a>
<FONT color="green">183</FONT>         * @param n - column index<a name="line.183"></a>
<FONT color="green">184</FONT>         * @return - array element<a name="line.184"></a>
<FONT color="green">185</FONT>         */<a name="line.185"></a>
<FONT color="green">186</FONT>        public T get( int m, int n )<a name="line.186"></a>
<FONT color="green">187</FONT>        {<a name="line.187"></a>
<FONT color="green">188</FONT>            if ( isComplex() )<a name="line.188"></a>
<FONT color="green">189</FONT>            {<a name="line.189"></a>
<FONT color="green">190</FONT>                throw new IllegalStateException("Cannot use this method for Complex matrices");<a name="line.190"></a>
<FONT color="green">191</FONT>            }<a name="line.191"></a>
<FONT color="green">192</FONT>            return getReal(m, n);<a name="line.192"></a>
<FONT color="green">193</FONT>        }<a name="line.193"></a>
<FONT color="green">194</FONT>        /**<a name="line.194"></a>
<FONT color="green">195</FONT>         * @param index     the array index of the desired value<a name="line.195"></a>
<FONT color="green">196</FONT>         */<a name="line.196"></a>
<FONT color="green">197</FONT>        public T get ( int index )<a name="line.197"></a>
<FONT color="green">198</FONT>        {<a name="line.198"></a>
<FONT color="green">199</FONT>            if ( isComplex() )<a name="line.199"></a>
<FONT color="green">200</FONT>            {<a name="line.200"></a>
<FONT color="green">201</FONT>                throw new IllegalStateException("Cannot use this method for Complex matrices");<a name="line.201"></a>
<FONT color="green">202</FONT>            }<a name="line.202"></a>
<FONT color="green">203</FONT>            return real[index];<a name="line.203"></a>
<FONT color="green">204</FONT>        }<a name="line.204"></a>
<FONT color="green">205</FONT>        /**<a name="line.205"></a>
<FONT color="green">206</FONT>         * @param vector    the vector to set<a name="line.206"></a>
<FONT color="green">207</FONT>         */<a name="line.207"></a>
<FONT color="green">208</FONT>        public void set(T[] vector)<a name="line.208"></a>
<FONT color="green">209</FONT>        {<a name="line.209"></a>
<FONT color="green">210</FONT>            if ( isComplex() )<a name="line.210"></a>
<FONT color="green">211</FONT>            {<a name="line.211"></a>
<FONT color="green">212</FONT>                throw new IllegalStateException("Cannot use this method for Complex matrices");<a name="line.212"></a>
<FONT color="green">213</FONT>            }<a name="line.213"></a>
<FONT color="green">214</FONT>            setReal(vector);<a name="line.214"></a>
<FONT color="green">215</FONT>        }<a name="line.215"></a>
<FONT color="green">216</FONT>        /* (non-Javadoc)<a name="line.216"></a>
<FONT color="green">217</FONT>         * @see com.jmatio.types.MLArray#contentToString()<a name="line.217"></a>
<FONT color="green">218</FONT>         */<a name="line.218"></a>
<FONT color="green">219</FONT>        @Override<a name="line.219"></a>
<FONT color="green">220</FONT>            public String contentToString()<a name="line.220"></a>
<FONT color="green">221</FONT>        {<a name="line.221"></a>
<FONT color="green">222</FONT>            StringBuffer sb = new StringBuffer();<a name="line.222"></a>
<FONT color="green">223</FONT>            sb.append(name + " = \n");<a name="line.223"></a>
<FONT color="green">224</FONT>            <a name="line.224"></a>
<FONT color="green">225</FONT>            if ( getSize() &gt; 1000 )<a name="line.225"></a>
<FONT color="green">226</FONT>            {<a name="line.226"></a>
<FONT color="green">227</FONT>                sb.append("Cannot display variables with more than 1000 elements.");<a name="line.227"></a>
<FONT color="green">228</FONT>                return sb.toString();<a name="line.228"></a>
<FONT color="green">229</FONT>            }<a name="line.229"></a>
<FONT color="green">230</FONT>            for ( int m = 0; m &lt; getM(); m++ )<a name="line.230"></a>
<FONT color="green">231</FONT>            {<a name="line.231"></a>
<FONT color="green">232</FONT>               sb.append("\t");<a name="line.232"></a>
<FONT color="green">233</FONT>               for ( int n = 0; n &lt; getN(); n++ )<a name="line.233"></a>
<FONT color="green">234</FONT>               {<a name="line.234"></a>
<FONT color="green">235</FONT>                   sb.append( getReal(m,n) );<a name="line.235"></a>
<FONT color="green">236</FONT>                   if ( isComplex() )<a name="line.236"></a>
<FONT color="green">237</FONT>                   {<a name="line.237"></a>
<FONT color="green">238</FONT>                       sb.append("+" + getImaginary(m,n) );<a name="line.238"></a>
<FONT color="green">239</FONT>                   }<a name="line.239"></a>
<FONT color="green">240</FONT>                   sb.append("\t");<a name="line.240"></a>
<FONT color="green">241</FONT>               }<a name="line.241"></a>
<FONT color="green">242</FONT>               sb.append("\n");<a name="line.242"></a>
<FONT color="green">243</FONT>            }<a name="line.243"></a>
<FONT color="green">244</FONT>            return sb.toString();<a name="line.244"></a>
<FONT color="green">245</FONT>        }<a name="line.245"></a>
<FONT color="green">246</FONT>        /* (non-Javadoc)<a name="line.246"></a>
<FONT color="green">247</FONT>         * @see java.lang.Object#equals(java.lang.Object)<a name="line.247"></a>
<FONT color="green">248</FONT>         */<a name="line.248"></a>
<FONT color="green">249</FONT>        @Override<a name="line.249"></a>
<FONT color="green">250</FONT>        public boolean equals(Object o)<a name="line.250"></a>
<FONT color="green">251</FONT>        {<a name="line.251"></a>
<FONT color="green">252</FONT>            if ( o instanceof  MLNumericArray )<a name="line.252"></a>
<FONT color="green">253</FONT>            {<a name="line.253"></a>
<FONT color="green">254</FONT>                return Arrays.equals( real, ((MLNumericArray)o).real )<a name="line.254"></a>
<FONT color="green">255</FONT>                        &amp;&amp; Arrays.equals( imaginary, ((MLNumericArray)o).imaginary )<a name="line.255"></a>
<FONT color="green">256</FONT>                        &amp;&amp; Arrays.equals( dims, ((MLNumericArray)o).dims )<a name="line.256"></a>
<FONT color="green">257</FONT>                        ;<a name="line.257"></a>
<FONT color="green">258</FONT>            }<a name="line.258"></a>
<FONT color="green">259</FONT>            return super.equals( o );<a name="line.259"></a>
<FONT color="green">260</FONT>        }<a name="line.260"></a>
<FONT color="green">261</FONT>        <a name="line.261"></a>
<FONT color="green">262</FONT>    }<a name="line.262"></a>




























































</PRE>
</BODY>
</HTML>
